<?php
/**
 * VMSynthDashboard
 * @author Nordmograph <contact@nordmograph.com>
 * @link http://www.nordmograph.com
 * @license GNU/GPL v3
**/
defined('_JEXEC') or die('Restricted access');
abstract class modVmSynthDashboardHelper
{
	public function getCurrency() 
	{
		$db = &JFactory::getDBO();
		$q ="SELECT vc.`currency_symbol` , vc.`currency_positive_style` , vc.`currency_decimal_place` , vc.`currency_decimal_symbol` , vc.`currency_thousands` 
		FROM `#__virtuemart_currencies` vc 
		LEFT JOIN `#__virtuemart_vendors` vv ON vv.`vendor_currency` = vc.`virtuemart_currency_id` 
		WHERE vv.`virtuemart_vendor_id` ='1' " ;		
		$db->setQuery($q);
		$main_currency = $db->loadRow();
		return $main_currency;
	}
	
	public function getXMonthSales($params, $x) 
	{
		$this_year =  date("Y");
		$x_month =  date("m")-($x ) ;		
		if($x_month <1){
			$x_month = 12 + $x_month;
			$this_year = $this_year -1 ;
		}
		if(strlen($x_month)<2)
			$x_month = '0'.$x_month;
		$x_month = $this_year.'-'.$x_month;
		$db = &JFactory::getDBO();
		$q ="SELECT `order_total` FROM `#__virtuemart_orders` WHERE (`order_status`='C' OR `order_status`='S' ) AND SUBSTRING(`created_on`,1,7) = '".$x_month."' " ;		
		$db->setQuery($q);
		$xmonthorders = $db->loadObjectList();
		$x_month_total = 0;
		$orders_count =0;
		foreach($xmonthorders as $xmonthorder){
			$x_month_total = $x_month_total + $xmonthorder->order_total;
			$orders_count++;
		}
		$monthsales_array = array();
		$monthsales_array[x_month_total] = $x_month_total;
		$monthsales_array[orders_count] = $orders_count;
		
		return $monthsales_array;
	}
	
	


	function getOrders($params){
		$db		= JFactory::getDbo();
		$lang	= JFactory::getLanguage();
		$orders_limit = $params->get('orders_limit', '13');
		$q = "SELECT vo.`virtuemart_order_id` , vo.`virtuemart_user_id` , vo.`virtuemart_vendor_id` , vo.`order_number` , vo.`order_total` , vo.`order_currency` , vo.`order_status` , vo.`created_on` , vo.`created_by` ,
		cust.`name` AS custname ,
		v.`created_by` ,
		vendor.`name` AS vendorname ,
		vos.`order_status_name` 
		FROM `#__virtuemart_orders` vo 
		LEFT JOIN `#__users` AS cust ON cust.`id`=vo.`created_by` 
		LEFT JOIN `#__virtuemart_vendors` v ON v.`virtuemart_vendor_id` = vo.`virtuemart_vendor_id` 
		LEFT JOIN `#__users` AS vendor ON vendor.`id` = v.`created_by` 
		LEFT JOIN `#__virtuemart_orderstates` vos ON vos.`order_status_code` = vo.`order_status` 
		ORDER BY vo.`created_on` DESC
		LIMIT ".$orders_limit ;
		$db->setQuery($q);
		$orders = $db->loadObjectList();
		return $orders;
		
		
		
	}
	
	function getReviews($params){
		$db		= JFactory::getDbo();
		$reviews_limit = $params->get('reviews_limit', '20');
		$lang 						= &JFactory::getLanguage();
		$langtag 					= $lang->get('tag');
		$dblangtag 					= strtolower(str_replace('-','_',$langtag));
		$q = "SELECT vrr.`virtuemart_rating_review_id` , vrr.`virtuemart_product_id` , vrr.`comment` , vrr.`review_rates` , vrr.`review_ratingcount` , vrr.`created_by` , vrr.`created_on` , vrr.`published` ,
		vpl.`product_name` , 
		u.`name` 
		FROM `#__virtuemart_rating_reviews`  vrr 
		LEFT JOIN `#__virtuemart_products_".$dblangtag."` vpl ON vpl.`virtuemart_product_id` = vrr.`virtuemart_product_id` 
		LEFT JOIN `#__users` u ON u.`id` = vrr.`created_by` 
		ORDER BY vrr.`published` ASC , vrr.`created_on` DESC
		
		
		LIMIT ".$reviews_limit ;
		$db->setQuery($q);
		$reviews = $db->loadObjectList();
		return $reviews;
		
		
	}
	function getProducts($params){
		$db		= JFactory::getDbo();
		$products_limit = $params->get('products_limit', '20');
		$lang 						= &JFactory::getLanguage();
		$langtag 					= $lang->get('tag');
		$dblangtag 					= strtolower(str_replace('-','_',$langtag));
		$q = "SELECT vpl.`virtuemart_product_id` , vpl.`product_name` ,
		vp.`product_sku`, vp.`published` ,
		vpc.`virtuemart_category_id` ,
		vcl.`category_name`,
		vpp.`product_price` 
		FROM  `#__virtuemart_products_".$dblangtag."` vpl 
		LEFT JOIN `#__virtuemart_products` vp ON vp.`virtuemart_product_id` = vpl.`virtuemart_product_id` 
		LEFT JOIN `#__virtuemart_product_categories` vpc ON vpc.`virtuemart_product_id` = vpl.`virtuemart_product_id`  
		LEFT JOIN `#__virtuemart_categories_".$dblangtag."` vcl ON vcl.`virtuemart_category_id` = vpc.`virtuemart_category_id` 
		LEFT JOIN `#__virtuemart_product_prices` vpp ON vpp.`virtuemart_product_id` = vpl.`virtuemart_product_id` 
		ORDER BY vpl.`virtuemart_product_id` DESC 
		LIMIT ".$products_limit ;
		$db->setQuery($q);
		$products = $db->loadObjectList();
		return $products;
		
		
	}
	function getShoppers($params){
		$db		= JFactory::getDbo();
		$shoppers_limit = $params->get('shoppers_limit', '20');
		$q = "SELECT vu.`virtuemart_user_id` , vu.`name`  , vu.`created_on` ,
		u.`username` , u.`block` 
		FROM `#__virtuemart_userinfos` vu 
		LEFT JOIN `#__users` u ON u.`id` = vu.`virtuemart_user_id` 
		ORDER BY vu.`virtuemart_userinfo_id` DESC
		LIMIT ".$shoppers_limit ;
		$db->setQuery($q);
		$shoppers = $db->loadObjectList();
		return $shoppers;
		
		
	}
}